Class {
	#name : #Znock,
	#superclass : #Object,
	#instVars : [
		'bases',
		'expectations'
	],
	#classInstVars : [
		'default'
	],
	#category : #Znock
}

{ #category : #accessing }
Znock class >> default [

	^ default ifNil: [ default := self new ]
]

{ #category : #accessing }
Znock >> addExpectation: aZnClient [
	^ self expectations add: aZnClient
]

{ #category : #accessing }
Znock >> baseFor: descriptor [
	^ (self bases at: descriptor ifAbsentPut: [ ZnockBase in: self url: descriptor asHostFirstUrl ])
		resetState;
		yourself
]

{ #category : #accessing }
Znock >> bases [
	^ bases ifNil: [ bases := Dictionary new ]
]

{ #category : #operations }
Znock >> consumeExpectationFor: aZnockClient [ 
	^ expectations
		detect: [ :one | aZnockClient matches: one ]
		ifFound: [ :one | expectations remove: one. one ]
		ifNone: [ nil ]
]

{ #category : #accessing }
Znock >> expectations [
	^ expectations ifNil: [ expectations := OrderedCollection new ]
]

{ #category : #public }
Znock >> pendingExpectations [
	^ self expectations copy.
]

{ #category : #public }
Znock >> removeAll [
	self expectations removeAll
]
