Class {
	#name : #ZnockClient,
	#superclass : #ZnClient,
	#instVars : [
		'interceptor'
	],
	#category : #Znock
}

{ #category : #'instance creation' }
ZnockClient class >> newWithInterceptor: aZnock [ 
	^ self new
		interceptor: aZnock;
		yourself
]

{ #category : #'private protocol' }
ZnockClient >> executeRequestResponse [
	^ (interceptor consumeExpectationFor: self)
		ifNotNil: [ :expectation | response := expectation response. response contents ]
		ifNil: [ super executeRequestResponse ]
]

{ #category : #accessing }
ZnockClient >> interceptor: anObject [
	interceptor := anObject
]

{ #category : #comparing }
ZnockClient >> matches: aZnockExpectation [
	| req exp |
	req := self request.
	exp := aZnockExpectation request.
	exp url scheme ifNotNil:
		[ :scheme | scheme = req url scheme ifFalse: [ ^ false ] ].
	exp url authority ifNotNil:
		[ :authority | authority = req url authority ifFalse: [ ^ false ] ].
	exp method ifNotNil:
		[ :method | method = req method ifFalse: [ ^ false ] ].

	^ true
]
